<?php
# -- BEGIN LICENSE BLOCK ----------------------------------
#
# This file is part of ItsaRiddle, a plugin for Dotclear 2.
#
# Copyright (c) 2009-2010 AkhThoT
#
# Licensed under the GPL version 2.0 license.
# See LICENSE file or
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
#
# -- END LICENSE BLOCK ------------------------------------
if (!defined('DC_RC_PATH')) { return; }

if ($GLOBALS['core']->blog->settings->sItsaRiddle_Ok)
{
	$GLOBALS['core']->addBehavior('coreBlogGetPosts', array('BehaviorsItsaRiddle','coreBlogGetPosts'));
	$GLOBALS['core']->addBehavior('coreBeforeCommentCreate', array('BehaviorsItsaRiddle','coreBeforeCommentCreate'));
}

class BehaviorsItsaRiddle
{
	public static function coreBlogGetPosts(&$rs)
	{
		$f = $rs->extensions();
		$GLOBALS['PrvExtCItsaRiddle'] = $f['getContent'];
		$GLOBALS['PrvExtEItsaRiddle'] = $f['getExcerpt'];

		$rs->extend('rsItsaRiddle');
	}

	public static function coreBeforeCommentCreate(&$blog,&$cur)
	{
		global $core,$_ctx;
		
		if ($core->blog->settings->sItsaRiddle_Moderation
			and (preg_match('#<span itsariddle="#',$_ctx->posts->post_excerpt_xhtml)
			or preg_match('#<span itsariddle="#',$_ctx->posts->post_content_xhtml)))
		{
			$aTags = unserialize($_ctx->posts->post_meta);
			if ($core->blog->settings->sItsaRiddle_Tag == ''
				or in_array($core->blog->settings->sItsaRiddle_Tag,$aTags['tag']))
				$cur->comment_status = -1;
		}
	}
}

class rsItsaRiddle
{
	public static function getContent($rs,$absolute_urls=false)
	{
		if (isset($GLOBALS['_ctx']) && preg_match('#<span itsariddle="#',$rs->post_content_xhtml)) $GLOBALS['_ctx']->short_feed_items = false;
		
		$c = call_user_func_array($GLOBALS['PrvExtCItsaRiddle'],array($rs,$absolute_urls));
		
		return self::getBoth('C',$rs,$c);
	}

	public static function getExcerpt($rs,$absolute_urls=false)
	{
		if (isset($GLOBALS['_ctx']) && preg_match('#<span itsariddle="#',$rs->post_content_xhtml)) $GLOBALS['_ctx']->short_feed_items = false;
		
		$c = call_user_func_array($GLOBALS['PrvExtEItsaRiddle'],array($rs,$absolute_urls));
		
		return self::getBoth('E',$rs,$c);
	}

	public static function getBoth($where,$rs,$c)
	{
		global $core;

		if (preg_match('#<span itsariddle="#',$c))
		{
			$c = ' '.$c;
			
			$MxID = 0;
			$pos = 0;

# identifions les devinettes en ajoutant un paramètre ID=E<pos> ou ID=C<pos>
			$DoLoop = true;
			while ($DoLoop)
			{
				$pos = stripos($c,'<span itsariddle="',$pos);
				if ($pos)
				{
					$MxID++;
					$c = substr($c,0,$pos+18).'ID='.$where.$MxID.'/'.substr($c,$pos+18);
					$pos += 18;
				}
				else
					$DoLoop = false;
			}
# plusieurs zones
			if ($MxID > 1)
			{
				$StyleForm = '';
				if ($core->blog->settings->sItsaRiddle_StyleForm != '')
					$StyleForm = ' style="'.$core->blog->settings->sItsaRiddle_StyleForm.'"';
				$c = '<form'.$StyleForm.' action="'.$_SERVER['REQUEST_URI'].'" method="post">'.$c.'</form>';
			}

			while (preg_match('#<span itsariddle="#',$c))
			{
				$posDeb = stripos($c,'<span itsariddle="');
				$posParam =	stripos($c,'"',$posDeb+18);
				$posEndParam = stripos($c,'>',$posParam)+1;
				$posEnd = $posEndParam;

				$param = explode('/',substr($c,$posDeb+18,$posParam-$posDeb-18));

				$CpPile = 1;
				$FlgNotFound = true;
				while ($FlgNotFound)
				{
					$posSPANd = stripos($c,'<span',$posEnd);
					$posSPANf = stripos($c,'</span',$posEnd);
				
					if (!$posSPANf)
					{
						$CpPile = 0;
						$c .= '</span>';
						$posEnd = strlen($c);
					}
					else if ($posSPANd and $posSPANd < $posSPANf)
					{
						$CpPile += 1;
						$posEnd = $posSPANd + 7;
					}
					else if ($posSPANf)
					{
						$CpPile -= 1;
						$posEnd = $posSPANf + 7;
					}
					if (!$CpPile) $FlgNotFound = false;
				}
			
				$flgCASESENSITIVE = false;
				$flgKEEPSPACE = false;
				$flgKEEPACCENT = false;
				$NbAnswer = 0;
				$Answers = array();

				foreach ($param as $p)
				{
					switch ($p)
					{
					case 'ITSARIDDLE':
						break;
					case 'CASESENSITIVE':
						$flgCASESENSITIVE = true;
						break;
					case 'KEEPSPACE':
						$flgKEEPSPACE = true;
						break;
					case 'KEEPACCENT':
						$flgKEEPACCENT = true;
						break;
					default:
						if ($p != '')
						{
							if (substr($p,0,3) == 'ID=')
							{
								$ID = substr($p,3);
							}
							else
							{
								$Answers[$NbAnswer] = $p;
								$NbAnswer += 1;
							}
						}
						break;
					}
				}
				$Nb = 0;
				while ($Nb != $NbAnswer)
				{
					$Answers[$Nb] = self::Build($Answers[$Nb],$flgCASESENSITIVE,$flgKEEPSPACE,$flgKEEPACCENT);
					$Nb += 1;
				}
			
				$newContent = substr($c,0,$posDeb);

				if (isset($_COOKIE['dc_ItsaRiddle_'.$core->blog->id]))
					$ItsaRiddleArray = unserialize($_COOKIE['dc_ItsaRiddle_'.$core->blog->id]);
				else
					$ItsaRiddleArray = array();
			
				$flgOk = false;
				if ($core->blog->settings->sItsaRiddle_Cookie)
					$flgOk = self::TsTAnswer($Answers,$ItsaRiddleArray[$rs->post_id.'-'.$ID]);

				if (!$flgOk and isset($_POST['ItsaRiddle-'.$rs->post_id.'-'.$ID]))
				{
					$Possible = self::Build($_POST['ItsaRiddle-'.$rs->post_id.'-'.$ID],$flgCASESENSITIVE,$flgKEEPSPACE,$flgKEEPACCENT);
				
					$flgOk = self::TsTAnswer($Answers,$Possible);
					if ($flgOk and $core->blog->settings->sItsaRiddle_Cookie)
					{
						$ItsaRiddleArray[$rs->post_id.'-'.$ID] = $Possible;
						setcookie('dc_ItsaRiddle_'.$core->blog->id,serialize($ItsaRiddleArray),time()+60*60*24*366,'/');
					}
				}

				if (!$flgOk)
				{
					$StyleP = '';
					$Ico = '';
					$StyleAnswer = '';
					$StyleOk = '';
					if ($core->blog->settings->sItsaRiddle_StyleP != '')
						$StyleP = ' style="'.$core->blog->settings->sItsaRiddle_StyleP.'"';
					if ($core->blog->settings->sItsaRiddle_Icon != '')
						$Ico = '<img style="vertical-align: middle;" src="index.php?pf=ItsaRiddle/img-admin/Serrure.png" />&nbsp;';
					if ($core->blog->settings->sItsaRiddle_StyleAnswer != '')
						$StyleAnswer = ' style="'.$core->blog->settings->sItsaRiddle_StyleAnswer.'"';
					if ($core->blog->settings->sItsaRiddle_StyleOk != '')
						$StyleOk = ' style="'.$core->blog->settings->sItsaRiddle_StyleOk.'"';

					if ($MxID == 1)
					{
						$StyleForm = '';
						if ($core->blog->settings->sItsaRiddle_StyleForm != '')
							$StyleForm = ' style="'.$core->blog->settings->sItsaRiddle_StyleForm.'"';
						$newContent .= '<form'.$StyleForm.' action="'.$_SERVER['REQUEST_URI'].'" method="post">';
					}

					$newContent .= '
	<p'.$StyleP.'>
		'.$Ico.'
		<input'.$StyleAnswer.' type="text" size="40" maxlength="255" name="ItsaRiddle-'.$rs->post_id.'-'.$ID.'" value="'.$_POST['ItsaRiddle-'.$rs->post_id.'-'.$ID].'" />
		<input'.$StyleOk.' type="submit" value="'.$core->blog->settings->sItsaRiddle_TxTOk.'" />
	</p>';
					if ($MxID == 1)
						$newContent .= '</form>';
					
					$newContent .= substr($c,$posEnd);
				}
				else
					$newContent .= substr($c,$posEndParam,$posEnd-$posEndParam-7)."\n".'
		<input type="hidden" name="ItsaRiddle-'.$rs->post_id.'-'.$ID.'" value="'.$_POST['ItsaRiddle-'.$rs->post_id.'-'.$ID].'" />
			'.substr($c,$posEnd);

				$c = $newContent;
			}
		}
		return $c;
	}

	public static function Build($a,$flgCASESENSITIVE,$flgKEEPSPACE,$flgKEEPACCENT)
	{
		# Ça a l'air tout bête, mais encode / decode j'ai bien mis une bonne heure pour trouver :-)
		if (!$flgKEEPACCENT)
		{
			$Avec = "ÀÁÂÃÄÅÇÈÉÊËÌÍÎÏÑÒÓÔÕÖÙÚÛÜÝàáâãäåçèéêëìíîïñòóôõöùúûüý";
			$Sans = "AAAAAACEEEEIIIINOOOOOUUUUYaaaaaaceeeeiiiinooooouuuuy";
			$a = utf8_encode(strtr(utf8_decode($a),$Avec,$Sans));
		}
		if (!$flgKEEPSPACE)
			$a = str_replace(' ','',$a);

		if (!$flgCASESENSITIVE)
			$a = utf8_encode(strtolower(utf8_decode($a)));

		return $a;
	}

	public static function TsTAnswer($A,$P)
	{
		foreach ($A as $a)
			if ($P == $a)
				return true;

		return false;
	}
}
?>